import java.awt.Dimension;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.awt.event.KeyEvent;
import java.awt.event.KeyListener;
import java.awt.event.WindowEvent;
import java.awt.event.WindowListener;
import java.util.Observable;
import java.util.Observer;

import javax.swing.JButton;
import javax.swing.JDialog;
import javax.swing.JFrame;
import javax.swing.JLabel;
import javax.swing.SwingUtilities;

/**
 * 
 * Abschlussnoten
 * 
 * @author $Author: Thomas Kramer
 * @version $Revision: $, $Date: 01.11.2012 UTC
 */
public class FinalGrades extends JDialog implements WindowListener,
      Observer
{
   public Controller controller = null;

   public CustomNoteField naNote = null;

   public CustomNoteField nkNote = null;
   
   private JLabel edNote;

   /**
    * 
    * Konstruktor
    * 
    */
   public FinalGrades(JFrame owner)
   {
      super(owner, "Abschlussnoten");
      addWindowListener(this);
      setLayout(null);

      JLabel na = new JLabel("Note Abschlussarbeit:");
      na.setBounds(20, 5, 200, 30);
      add(na);
      naNote = new CustomNoteField(0);
      naNote.addKeyListener(new KeyListener()
      {
         @Override
         public void keyPressed(KeyEvent arg0)
         {
         }

         @Override
         public void keyReleased(KeyEvent arg0)
         {
            /**
             * Daten ins Model bernehmen OHNE bereits auf Festplatte zu
             * speichern
             */
            controller.triggerConfirmDataFromFG1();
            
            /**
             * ND im Form aktualisieren
             */
            edNote.setText(Float.toString(controller.getPassedNDWithGraduation()).substring(0, 4));            
         }

         @Override
         public void keyTyped(KeyEvent arg0)
         {
         }
      });           
      naNote.setBounds(210, 5, 30, 30);
      add(naNote);
      JLabel nk = new JLabel("Note Kolloquium:");
      nk.setBounds(20, 40, 200, 30);
      add(nk);
      nkNote = new CustomNoteField(0);
      nkNote.addKeyListener(new KeyListener()
      {
         @Override
         public void keyPressed(KeyEvent arg0)
         {
         }

         @Override
         public void keyReleased(KeyEvent arg0)
         {
            /**
             * Daten ins Model bernehmen OHNE bereits auf Festplatte zu
             * speichern
             */
            controller.triggerConfirmDataFromFG1();
            
            /**
             * ND im Form aktualisieren
             */
            edNote.setText(Float.toString(controller.getPassedNDWithGraduation()).substring(0, 4));            
         }

         @Override
         public void keyTyped(KeyEvent arg0)
         {
         }
      });            
      nkNote.setBounds(210, 40, 30, 30);
      add(nkNote);
      JLabel ed = new JLabel("Erzielte Durchschnittsnote:");
      ed.setBounds(20, 75, 200, 30);
      add(ed);
      edNote = new JLabel("___");
      edNote.setBounds(210, 75, 200, 30);
      add(edNote);

      JButton closeButton = new JButton("Schlieen");
      closeButton.setBounds(140, 120, 100, 30);
      add(closeButton);
      closeButton.addActionListener(new ActionListener()
      {
         @Override
         public void actionPerformed(ActionEvent arg0)
         {
            SwingUtilities.invokeLater(new Runnable()
            {
               public void run()
               {
                  dispose();
               }
            });
         }
      });

      // Gre des Fensters setzen
      setMinimumSize(new Dimension(320, 200));
   }

   // Implementiere WindowListener
   /**
    * wird aufgerufen wenn X-Button gedrckt wurde
    */
   public void windowClosing(WindowEvent event)
   {
      closeForm();
   }

   /**
    * wird aufgerufen wenn ber dispose() geschlossen wurde
    */
   public void windowClosed(WindowEvent event)
   {
      closeForm();
   }

   /**
    * weitere Methoden siehe
    * http://openbook.galileodesign.de/javainsel5/javainsel15_001
    * .htm#Rxx747java15001040005391F040104
    */
   public void windowDeiconified(WindowEvent event)
   {
   }

   public void windowIconified(WindowEvent event)
   {
   }

   public void windowActivated(WindowEvent event)
   {
   }

   public void windowDeactivated(WindowEvent event)
   {
   }

   public void windowOpened(WindowEvent event)
   {
   }

   /**
    * 
    * Separate Funktion fr Schlieen des Fensters
    * 
    */
   private void closeForm()
   {
      /**
       * Daten bernehmen UND auf Festplatte speichern
       */
      controller.triggerConfirmDataFromFG2();
   }

   @Override
   public void update(Observable o, Object arg)
   {
      naNote.setText(Float.toString(controller.dataModel.naNote));
      nkNote.setText(Float.toString(controller.dataModel.nkNote));      
      edNote.setText(Float.toString(controller.getPassedNDWithGraduation()));      
   }
}
