import javax.swing.JButton;
import javax.swing.JDialog;
import javax.swing.JFrame;
import javax.swing.JOptionPane;
import javax.swing.JPanel;
import javax.swing.JRadioButton;
import javax.swing.JScrollPane;
import javax.swing.JTextArea;
import javax.swing.JTextField;
import javax.swing.ScrollPaneConstants;
import javax.swing.SwingUtilities;

import java.awt.Dimension;
import java.awt.GridLayout;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.awt.event.KeyEvent;
import java.awt.event.KeyListener;
import java.awt.event.WindowEvent;
import java.awt.event.WindowListener;
import java.util.ArrayList;
import java.util.Observable;
import java.util.Observer;

/**
 * 
 * Klasse fr Fcher-Verwaltung
 * 
 * @author $Author: Thomas Kramer
 * @version $Revision: $, $Date: 01.11.2012 UTC
 */
public class SubjectManagement extends JDialog implements
      WindowListener, Observer
{
   public Controller controller = null;

   private JPanel GridPanel = new JPanel();

   public ArrayList<CustomSubjectField> subjects = new ArrayList<CustomSubjectField>();

   public ArrayList<CustomCPField> CP = new ArrayList<CustomCPField>();

   public ArrayList<JRadioButton> subjectType1 = new ArrayList<JRadioButton>();

   public ArrayList<JRadioButton> subjectType2 = new ArrayList<JRadioButton>();

   public ArrayList<JButton> closeButtons = new ArrayList<JButton>();

   /**
    * 
    * Konstruktor
    * 
    */
   public SubjectManagement(JFrame owner)
   {
      super(owner, "Fcher-Verwaltung");
      addWindowListener(this);
      setLayout(null);            

      GridPanel.setLayout(new GridLayout(0, 5));
      for (int j = 0; j < 2; j++)
      {
         addButtons();
      }

      JScrollPane sp = new JScrollPane(GridPanel,
            ScrollPaneConstants.VERTICAL_SCROLLBAR_ALWAYS,
            ScrollPaneConstants.HORIZONTAL_SCROLLBAR_NEVER);
      sp.setBounds(10, 15, 565, 100);
      add(sp);

      JButton addButton = new JButton("+ Hinzufgen");
      addButton.addActionListener(new ActionListener()
      {
         @Override
         public void actionPerformed(ActionEvent arg0)
         {
            SwingUtilities.invokeLater(new Runnable()
            {
               public void run()
               {
                  addButtons();

                  // Formular muss danach neu gezeichnet werden
                  repaint();
                  GridPanel.repaint();
               }
            });
         }
      });
      addButton.setBounds(50, 120, 400, 30);
      add(addButton);

      JButton closeButton = new JButton("Schlieen");
      closeButton.addActionListener(new ActionListener()
      {
         @Override
         public void actionPerformed(ActionEvent arg0)
         {
            SwingUtilities.invokeLater(new Runnable()
            {
               public void run()
               {
                  dispose();
               }
            });
         }
      });
      closeButton.setBounds(400, 160, 160, 30);
      add(closeButton);

      // Gre des Fensters setzen
      setMinimumSize(new Dimension(600, 250));
   }

   private void addButtons()
   {
      final CustomSubjectField subject = new CustomSubjectField(5);
      subject.addKeyListener(new KeyListener()
      {
         @Override
         public void keyPressed(KeyEvent arg0)
         {
         }

         @Override
         public void keyReleased(KeyEvent arg0)
         {
            String temp = subject.getText().trim();
            if (!temp.equals("") && !temp.equals(Constants.getSubjectDescription()))
            {
               for (int x = 0; x < subjects.size(); x++)
               {
                  if (subjects.get(x) != subject)
                  {
                     String temp2 = subjects.get(x).getText().trim();
                     if (temp2.equals(temp))
                     {
                        JOptionPane.showMessageDialog(null,
                              "Dieses Fach existiert bereits!",
                              "Achtung", JOptionPane.ERROR_MESSAGE);
                        subject.setText("");
                     }
                  }
               }
            }
         }

         @Override
         public void keyTyped(KeyEvent arg0)
         {
         }
      });

      subjects.add(subject);

      CustomCPField temp2 = new CustomCPField(2);
      CP.add(temp2);

      final JRadioButton FachArt_1 = new JRadioButton("PF");
      FachArt_1.setSelected(true);
      subjectType1.add(FachArt_1);
      final JRadioButton FachArt_2 = new JRadioButton("WF");
      FachArt_2.setSelected(false);
      subjectType2.add(FachArt_2);

      FachArt_1.addActionListener(new ActionListener()
      {
         @Override
         public void actionPerformed(ActionEvent arg0)
         {
            SwingUtilities.invokeLater(new Runnable()
            {
               public void run()
               {
                  FachArt_1.setSelected(true);
                  FachArt_2.setSelected(false);
               }
            });
         }
      });

      FachArt_2.addActionListener(new ActionListener()
      {
         @Override
         public void actionPerformed(ActionEvent arg0)
         {
            SwingUtilities.invokeLater(new Runnable()
            {
               public void run()
               {
                  FachArt_2.setSelected(true);
                  FachArt_1.setSelected(false);
               }
            });
         }
      });

      final JButton cbButton = new JButton("X");
      cbButton.addActionListener(new ActionListener()
      {
         @Override
         public void actionPerformed(ActionEvent arg0)
         {
            SwingUtilities.invokeLater(new Runnable()
            {
               public void run()
               {
                  int position = closeButtons.indexOf(cbButton);
                  
                  GridPanel.remove(subjects.get(position));
                  GridPanel.remove(CP.get(position));
                  GridPanel.remove(subjectType1.get(position));
                  GridPanel.remove(subjectType2.get(position));
                  GridPanel.remove(closeButtons.get(position));
                  
                  /**
                   * Eingabeflchen mssen nicht nur aus dem Grid,
                   * sondern auch aus der Arraylist gelscht werden
                   */
                  subjects.remove(position);
                  CP.remove(position);
                  subjectType1.remove(position);
                  subjectType2.remove(position);
                  closeButtons.remove(position);

                  // Formular muss danach neu gezeichnet werden
                  validate();
                  repaint();
               }
            });
         }
      });
      closeButtons.add(cbButton);

      GridPanel.add(subjects.get(subjects.size() - 1));
      GridPanel.add(CP.get(CP.size() - 1));
      GridPanel.add(subjectType1.get(subjectType1.size() - 1));
      GridPanel.add(subjectType2.get(subjectType2.size() - 1));
      GridPanel.add(closeButtons.get(closeButtons.size() - 1));
      GridPanel.setMaximumSize(new Dimension(10, 10));

      validate();
      repaint();
   }

   // Implementiere WindowListener
   /**
    * wird aufgerufen wenn X-Button gedrckt wurde
    */
   public void windowClosing(WindowEvent event)
   {
      closeForm();
   }

   /**
    * wird aufgerufen wenn ber dispose() geschlossen wurde
    */
   public void windowClosed(WindowEvent event)
   {
      closeForm();
   }

   /**
    * weitere Methoden siehe
    * http://openbook.galileodesign.de/javainsel5/javainsel15_001
    * .htm#Rxx747java15001040005391F040104
    */
   public void windowDeiconified(WindowEvent event)
   {
   }

   public void windowIconified(WindowEvent event)
   {
   }

   public void windowActivated(WindowEvent event)
   {
   }

   public void windowDeactivated(WindowEvent event)
   {
   }

   public void windowOpened(WindowEvent event)
   {
   }

   /**
    * 
    * Separate Funktion fr Schlieen des Fensters
    * 
    */
   private void closeForm()
   {
      // System.out.println(subjects.size());
      
      controller.triggerConfirmDataFromSM();
   }

   // Observer-Pattern
   @Override
   public void update(Observable arg0, Object arg1)
   {
      /** 
       * Felder zurcksetzen, auch die Arraylisten
       */
      GridPanel.removeAll();
      subjects.clear();
      CP.clear();
      subjectType1.clear();
      subjectType2.clear();
      closeButtons.clear();

      /**
       *  Daten in View bernehmen
       */
      for (SubjectDetails sd: controller.dataModel.getSubjectDetails())
      {
         addButtons();
         
         subjects.get(subjects.size()-1).setText(sd.getSubject());
         Integer temp = sd.getCP();
         CP.get(CP.size()-1).setText(temp.toString());
         subjectType1.get(subjectType1.size()-1).setSelected(sd.getSubjectType1());
         subjectType2.get(subjectType2.size()-1).setSelected(sd.getSubjectType2());                  
      }      
   }
}
