import java.awt.event.FocusAdapter;
import java.awt.event.FocusEvent;

import javax.swing.JTextField;
import javax.swing.text.AttributeSet;
import javax.swing.text.BadLocationException;
import javax.swing.text.Document;
import javax.swing.text.PlainDocument;

/* Warnungen unterdrcken */
@SuppressWarnings("serial")
public class CustomNoteField extends JTextField {
   JTextField instance;
   
   public CustomNoteField(int colsVisible) 
   {
     super(colsVisible);
     final JTextField instance = this;
     
     addFocusListener(new FocusAdapter() 
     {             
       @Override
       public void focusLost(FocusEvent e) 
       {
          if (instance.getText().trim().length() == 1)
          {
             // .0 anhngen
             instance.setText(instance.getText() + ".0");
          } else if (instance.getText().trim().length() == 2)
          {
             // 0 anhngen
             instance.setText(instance.getText() + "0");
          }
       }
     });       
   }
 
   protected Document createDefaultModel() 
   {
     return (Document) new CustomDocument();
   }
   
   @SuppressWarnings("serial")
   private class CustomDocument extends PlainDocument 
   {
      public void insertString(int offs, String str, AttributeSet a) throws BadLocationException 
      { 
         /**
          * Diese Methode wird bei Handeingaben fr jeden Buchstaben einmal aufgerufen - wenn dagegen
          * ein lngerer Text per Programm gesetzt wird nur einmal!
          */
           
          if (str == null) 
          {
            return;
          }                 
          
          // bers Programm gesetzt..
          if (str.equals("0.0"))
          {
             //
          } else if (str.length() == 3 & str.substring(0, 1).matches("[1-5]"))          
          {
             // wenn erste Ziffer kleiner 4 ist....
             if (Integer.parseInt(str.substring(0,1)) < 4)
             {
                // und die Zweite einer 037 entspricht.... 
                if (str.substring(2,3).matches("[037]"))
                {
                  super.insertString(offs, str, a);
                }             
             } else if (str.substring(2,3).equals("0"))
             {
                super.insertString(offs, str, a);             
             }
             //super.insertString(offs, str, a);          
          }       
        // von Hand Ziffer fr Ziffer eingegeben...
        // erste Zahl
        if (super.getLength() == 0 && str.matches("[1-5]"))
        {      
          super.insertString(offs, str, a);
        }
        // Punkt
        else if (super.getLength() == 1 && str.equals("."))
        {
          super.insertString(offs, str, a);          
        }
        // zweite Zahl
        else if (super.getLength() == 2)
        {
          // wenn die erste Zahl < 4 ist....
          if (Integer.parseInt(super.getText(0, 1)) < 4)
          {
            if (str.matches("[037]"))
            {
              super.insertString(offs, str, a);
            }
          } else 
          {
             // ansonsten nur 4.0 und 5.0 zulassen
             if (str.equals("0"))
             {
               super.insertString(offs, str, a);
             }                      
          }
        }            
      }   
   }
 }