import java.awt.event.FocusAdapter;
import java.awt.event.FocusEvent;

import javax.swing.JTextField;
import javax.swing.text.AttributeSet;
import javax.swing.text.BadLocationException;
import javax.swing.text.Document;
import javax.swing.text.PlainDocument;

/* Warnungen unterdrcken */
@SuppressWarnings("serial")
public class CustomSubjectField extends JTextField {
   JTextField instance;
   String defaultText = Constants.getSubjectDescription();
   
   public CustomSubjectField(int colsVisible) 
   {
     super(colsVisible);
     final JTextField instance = this;
     setText(defaultText);
         
     addFocusListener(new FocusAdapter() 
     {
       @Override
       public void focusGained(FocusEvent e) 
       {
         if (instance.getText().trim().equals(defaultText))
         {
           instance.setText("");
         }
       }
             
       @Override
       public void focusLost(FocusEvent e) 
       {
         if (instance.getText().trim().equals(""))
         {                 
           instance.setText(defaultText);
         }
       }
     });         
   }
 
   protected Document createDefaultModel() 
   {
     return (Document) new CustomDocument();
   }
   
   @SuppressWarnings("serial")
   private class CustomDocument extends PlainDocument 
   {  
     public void insertString(int offs, String str, AttributeSet a) throws BadLocationException 
     { 
       if (str == null) 
       {
         return;
       }             
              
       super.insertString(offs, str, a);              
     }
   }
 }