/**
 * 
 * Klasse um alle Daten eines Fachs zu speichern
 * 
 * @author $Author: Thomas Kramer
 * @version $Revision: $, $Date: 09.11.2012 UTC
 */
public class SubjectDetails
{
   private String subject;

   private int cp;

   private boolean subjectType1;

   private boolean subjectType2;

   /**
    * 
    * Konstruktor
    * 
    * @param subject
    *           Fach
    * @param cp
    *           Anzahl Credit Points
    * @param subjectType1
    *           Pflichtfach true/false
    * @param subjectType2
    *           Wahlfach true/false
    */
   public SubjectDetails(String subject, int cp,
         boolean subjectType1, boolean subjectType2)
   {
      this.subject = subject.trim();
      this.cp = cp;
      this.subjectType1 = subjectType1;
      this.subjectType2 = subjectType2;
   }

   /**
    * 
    * Getter fr Fachbezeichnung
    * 
    * @return
    */
   public String getSubject()
   {
      return this.subject;
   }

   /**
    * Setter fr Fachbezeichnung
    *
    * @param subject The subject to set.
    */
   public void setSubject(String subject)
   {
      this.subject = subject.trim();
   }

   /**
    * 
    * Getter fr Creditpoints eines Fachs
    * 
    * @return
    */
   public int getCP()
   {
      return cp;
   }
   
   /**
    * Setter fr Creditpoints eines FAchs
    *
    * @param cp The cp to set.
    */
   public void setCP(int cp)
   {
      this.cp = cp;
   }   

   /**
    * 
    * Getter fr Typ1 eines Fachs
    * 
    * @return true, wenn Pflichtfach - sonst false
    */
   public boolean getSubjectType1()
   {
      return this.subjectType1;
   }
   
   /**
    * Setter fr Typ1 eines Fachs
    *
    * @param subjectType1 The subjectType1 to set.
    */
   public void setSubjectType1(boolean subjectType1)
   {
      this.subjectType1 = subjectType1;
   }   

   /**
    * 
    * Getter fr Typ2 eines Fachs
    * 
    * @return true, wenn Wahlfach - sonst false
    */
   public boolean getSubjectType2()
   {
      return this.subjectType2;
   }

   /**
    * Setter fr Typ2 eines Fachs
    *
    * @param subjectType2 The subjectType2 to set.
    */
   public void setSubjectType2(boolean subjectType2)
   {
      this.subjectType2 = subjectType2;
   }  
}
